// comp 1672
// LinkedList.h - for lab 8
#ifndef _LinkedList_
#define _LinkedList_

#include "Node.h"
using namespace std;

class LinkedList {
public:
	LinkedList();
	LinkedList(const LinkedList &orig);
        LinkedList& operator=(const LinkedList &orig);
	virtual ~LinkedList();

        void pushBack(int newData);
	void insert(int newData, Node *n);
	int popBack();
        void remove(Node *);
        void display() const;
        Node *head() const;
        Node *getPrevious(Node *) const;
private:
	Node *myHead;
        Node *getTail() const;
};

#endif
