// test program for comp 1672
// Singly-linked list, lab 8
#include "LinkedList.h"
#include <iostream>


// test function for linked list class
int main()
{
  LinkedList list;
  Node *temp;

  //Test 1 - Create a List
  cout<<"\n******************** Test 1 - Create a List ******************\n\n";
  list.display();
  list.pushBack(1);
  cout<<"\nInserted 1 onto end of list: " << endl;
  list.display();
  list.pushBack(3);
  cout<<"\nInserted 3 onto end of list: " << endl;
  list.display();
  list.pushBack(4);
  cout<<"\nInserted 4 onto end of list: " <<  endl;
  list.display();
  cout<<"\nInserted 2 into second position: " <<  endl;
  list.insert(2,list.head());
  list.display();

  //Test 2 - Advance the pointer twice, then find its previous node
  cout<<"\n****Test 2 - Advance pointer twice, then find previous node***\n\n";
  cout << "List contents: \n";
  list.display();

  cout << "Start at the list head, move forward two elements, then back.\n";
  temp = list.head()->next()->next();
  cout << "Data for that list element: " << list.getPrevious(temp)->data() << endl;

  //Test 3 - Deleting a node with popBack
  cout<<"\n******* Test 3 - Delete last node using popBack function ******\n\n";
  cout << "Before: ";
  list.display();
  list.popBack();
  cout << "After: ";
  list.display();

  //Test 4 - Deleting a Node
  cout<<"\n************** Test 4 - Deleting a Node using remove **********\n\n";
  cout << "Before: ";
  list.display();
  temp = list.head()->next();
  cout<<"\nRemoving "<<temp->data()<< " from list:" <<endl;
  list.remove(temp);
  list.display();

  //Test 5 - Deleting and reinserting a Node
  cout<<"\n************* Test 5 - Deleting and reinserting a Node ********\n\n";
  cout << "Before: ";
  list.display();
  list.remove(list.head()->next());
  cout << "Second element removed from list: ";
  list.display();
  list.insert(3, list.head());
  cout << "Element reinserted into list: ";
  list.display();
}
