// comp 1672
// Node.h - for lab 8
#ifndef _Node_
#define _Node_

using namespace std;

class Node
{
public:
	// constructors
	Node();
	Node(const Node &orig);
        const Node & operator=(const Node &rhs);
	virtual ~Node();
	int data() const;         // accessor
	void data(int newData);   // set function

	Node* next() const;         // accessor
	void next(Node *nextNode);  // set function

private:
	int myData;
	Node *myNextNodePtr;
};

#endif
